--
-- PKG_COMPETICIONS
-- 
CREATE OR REPLACE PACKAGE PKG_COMPETICIONS AS

--
-- ALTA_ZONA
-- AFEGEIX UNA ZONA AL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION ALTA_ZONA (V_CODI VARCHAR2, V_NOM VARCHAR2) RETURN NUMBER;
--
-- BAIXA_ZONA
-- ELIMINA UNA ZONA DEL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION BAIXA_ZONA (V_CODI VARCHAR2) RETURN NUMBER;
--
-- MODIFICA_ZONA
-- MODIFICA UNA ZONA DEL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION MODIFICA_ZONA (V_CODI VARCHAR2, V_NOM VARCHAR2) RETURN NUMBER;
--
-- LLISTA_ZONES
-- RETORNA LA LLISTA DE ZONES
-- S'HA D'EXECUTAR AIX:
--   sql> variable c refcursor
--   sql> exec :c := pkg_competicions.llista_zones();
--   sql> print c;
--
-- REFERENCIA:
--   http://dba.stackexchange.com/questions/18256/return-many-rows-on-a-plsql-oracle10g
--
  FUNCTION LLISTA_ZONES RETURN SYS_REFCURSOR;
--
-- ZONA
-- RETORNA UNA ZONA SEGONS LA SEVA CLAU PRIMARIA
--
  FUNCTION ZONA (V_CODI VARCHAR2) RETURN ZONES%ROWTYPE;
--
-- CERCA_ZONA
-- RETORNA UNA ZONA SEGONS LES SEVES DADES
--
--  FUNCTION CERCA_ZONA (V_NOM VARCHAR2) RETURN VARCHAR2;



--
-- ALTA_COMPETICIO
-- AFEGEIX UNA COMPETICIO AL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION ALTA_COMPETICIO (V_CODI VARCHAR2, V_DESCRIPCIO VARCHAR2, V_ZONA VARCHAR2) RETURN NUMBER;
--
-- BAIXA_COMPETICIO
-- ELIMINA UNA COMPETICIO DEL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION BAIXA_COMPETICIO (V_CODI VARCHAR2) RETURN NUMBER;
--
-- MODIFICA_COMPETICIO
-- MODIFICA UNA COMPETICIO DEL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION MODIFICA_COMPETICIO (V_CODI VARCHAR2, V_DESCRIPCIO VARCHAR2, V_ZONA VARCHAR2) RETURN NUMBER;
--
-- LLISTA_COMPETICIONS
-- RETORNA LA LLISTA DE COMPETICIONS
-- S'HA D'EXECUTAR AIX:
--   sql> variable c refcursor
--   sql> exec :c := pkg_competicions.llista_competicions();
--   sql> print c;
--
-- REFERENCIA:
--   http://dba.stackexchange.com/questions/18256/return-many-rows-on-a-plsql-oracle10g
--
  FUNCTION LLISTA_COMPETICIONS RETURN SYS_REFCURSOR;
--
-- COMPETICIO
-- RETORNA UNA COMPETICIO SEGONS LA SEVA CLAU PRIMARIA
--
  FUNCTION COMPETICIO (V_CODI VARCHAR2) RETURN COMPETICIONS%ROWTYPE;
--
-- CERCA_COMPETICIO
-- RETORNA UNA COMPETICIO SEGONS LES SEVES DADES
--
--  FUNCTION CERCA_COMPETICIO (V_DESCRIPCIO VARCHAR2) RETURN VARCHAR2;



--
-- ALTA_TEMPORADA
-- AFEGEIX UN TEMPORADA AL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION ALTA_TEMPORADA (V_COMPETICIO VARCHAR2, V_AAAA NUMBER, V_INICI DATE, V_FINAL DATE) RETURN NUMBER;
--
-- BAIXA_TEMPORADA
-- ELIMINA UN TEMPORADA DEL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION BAIXA_TEMPORADA (V_COMPETICIO VARCHAR2, V_AAAA NUMBER) RETURN NUMBER;
--
-- MODIFICA_TEMPORADA
-- MODIFICA UN TEMPORADA DEL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION MODIFICA_TEMPORADA (V_COMPETICIO VARCHAR2, V_AAAA NUMBER, V_INICI DATE, V_FINAL DATE) RETURN NUMBER;
--
-- LLISTA_TEMPORADES
-- RETORNA LA LLISTA DE TEMPORADES
-- S'HA D'EXECUTAR AIX:
--   sql> variable c refcursor
--   sql> exec :c := pkg_competicions.llista_temporades();
--   sql> print c;
--
-- REFERENCIA:
--   http://dba.stackexchange.com/questions/18256/return-many-rows-on-a-plsql-oracle10g
--
  FUNCTION LLISTA_TEMPORADES RETURN SYS_REFCURSOR;
--
-- TEMPORADA
-- RETORNA UNA TEMPORADA SEGONS LA SEVA CLAU PRIMARIA
--
  FUNCTION TEMPORADA (V_COMPETICIO VARCHAR2, V_AAAA NUMBER) RETURN TEMPORADES%ROWTYPE;
--
-- CERCA_TEMPORADA
-- RETORNA UNA TEMPORADA SEGONS LES SEVES DADES
--
--  FUNCTION CERCA_TEMPORADA () RETURN VARCHAR2;



--
-- ALTA_EQUIP
-- AFEGEIX UN EQUIP AL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION ALTA_EQUIP (V_CODI VARCHAR2, V_NOM VARCHAR2, V_FUNDACIO DATE, V_PAIS VARCHAR2) RETURN NUMBER;
--
-- BAIXA_EQUIP
-- ELIMINA UN EQUIP DEL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION BAIXA_EQUIP (V_CODI VARCHAR2) RETURN NUMBER;
--
-- MODIFICA_EQUIP
-- MODIFICA UN EQUIP DEL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION MODIFICA_EQUIP (V_CODI VARCHAR2, V_NOM VARCHAR2, V_FUNDACIO DATE, V_PAIS VARCHAR2) RETURN NUMBER;
--
-- LLISTA_EQUIPS
-- RETORNA LA LLISTA DE EQUIPS
-- S'HA D'EXECUTAR AIX:
--   sql> variable c refcursor
--   sql> exec :c := pkg_competicions.llista_equips();
--   sql> print c;
--
-- REFERENCIA:
--   http://dba.stackexchange.com/questions/18256/return-many-rows-on-a-plsql-oracle10g
--
  FUNCTION LLISTA_EQUIPS RETURN SYS_REFCURSOR;
--
-- EQUIP
-- RETORNA UN EQUIP SEGONS LA SEVA CLAU PRIMARIA
--
  FUNCTION EQUIP (V_CODI VARCHAR2) RETURN EQUIPS%ROWTYPE;
--
-- CERCA_EQUIP
-- RETORNA UN EQUIP SEGONS LES SEVES DADES
--
--  FUNCTION CERCA_EQUIP (V_NOM VARCHAR2) RETURN VARCHAR2;



--
-- ALTA_JUGADOR
-- AFEGEIX UN JUGADOR AL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION ALTA_JUGADOR (V_NOM VARCHAR2, V_COGNOM1 VARCHAR2, V_COGNOM2 VARCHAR2, V_NAIXEMENT DATE, V_NACIONALITAT VARCHAR2) RETURN NUMBER;
  FUNCTION ALTA_JUGADOR (V_NOM VARCHAR2, V_COGNOM1 VARCHAR2, V_COGNOM2 VARCHAR2, V_NAIXEMENT DATE, V_NACIONALITAT VARCHAR2, V_ID IN OUT NUMBER) RETURN NUMBER;
--
-- BAIXA_JUGADOR
-- ELIMINA UN JUGADOR DEL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION BAIXA_JUGADOR (V_ID NUMBER) RETURN NUMBER;
--
-- MODIFICA_JUGADOR
-- MODIFICA UN JUGADOR DEL SISTEMA O TORNA EL CODI D'ERROR QUE S'HA PRODUIT
--
  FUNCTION MODIFICA_JUGADOR (V_ID NUMBER, V_NOM VARCHAR2, V_COGNOM1 VARCHAR2, V_COGNOM2 VARCHAR2, V_NAIXEMENT DATE, V_NACIONALITAT VARCHAR2) RETURN NUMBER;
--
-- LLISTA_JUGADORS
-- RETORNA LA LLISTA DE JUGADORS
-- S'HA D'EXECUTAR AIX:
--   sql> variable c refcursor
--   sql> exec :c := pkg_competicions.llista_jugadors();
--   sql> print c;
--
-- REFERENCIA:
--   http://dba.stackexchange.com/questions/18256/return-many-rows-on-a-plsql-oracle10g
--
  FUNCTION LLISTA_JUGADORS RETURN SYS_REFCURSOR;
--
-- JUGADOR
-- RETORNA UN JUGADOR SEGONS LA SEVA CLAU PRIMARIA
--
  FUNCTION JUGADOR (V_ID NUMBER) RETURN JUGADORS%ROWTYPE;
--
-- CERCA_JUGADOR
-- RETORNA UN JUGADOR SEGONS LES SEVES DADES
--
  FUNCTION CERCA_JUGADOR (V_NOM VARCHAR2, V_COGNOM1 VARCHAR2, V_COGNOM2 VARCHAR2) RETURN NUMBER;


--
-- FUNCTION ALTA_PLANTILLA
--

END PKG_COMPETICIONS;
/

--
-- PKG_COMPETICIONS BODY
-- 
CREATE OR REPLACE PACKAGE BODY PKG_COMPETICIONS AS

--
-- ZONES
--
  FUNCTION ALTA_ZONA (V_CODI VARCHAR2, V_NOM VARCHAR2) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        INSERT INTO ZONES
        VALUES (V_CODI, V_NOM);
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'INSERT', 'ZONA ' || V_CODI, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'INSERT', 'ZONA ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END ALTA_ZONA;
          
  FUNCTION BAIXA_ZONA (V_CODI VARCHAR2) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        DELETE FROM ZONES Z
        WHERE Z.CODI = V_CODI;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'DELETE', 'ZONA ' || V_CODI, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'DELETE', 'ZONA ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END BAIXA_ZONA;
  
  FUNCTION MODIFICA_ZONA (V_CODI VARCHAR2, V_NOM VARCHAR2) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        UPDATE ZONES Z 
        SET Z.NOM = V_NOM
        WHERE Z.CODI = V_CODI;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'UPDATE', 'ZONA ' || V_CODI, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'UPDATE', 'ZONA ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END MODIFICA_ZONA;
  
  FUNCTION LLISTA_ZONES RETURN SYS_REFCURSOR IS
  BEGIN
    DECLARE
      RETORN SYS_REFCURSOR;
    BEGIN
      BEGIN
        OPEN RETORN FOR
        SELECT *
        FROM ZONES;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT ALL', 'ZONA ', '0');
      EXCEPTION 
        WHEN OTHERS THEN
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT ALL', 'ZONA ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END LLISTA_ZONES;

  FUNCTION ZONA (V_CODI VARCHAR2) RETURN ZONES%ROWTYPE IS
  BEGIN
    DECLARE
      RETORN ZONES%ROWTYPE;
    BEGIN
      BEGIN
        SELECT *
        INTO RETORN
        FROM ZONES Z
        WHERE Z.CODI = V_CODI;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT', 'ZONA ' || V_CODI, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT', 'ZONA ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END ZONA;
  


--
-- COMPETICIONS
--
  FUNCTION ALTA_COMPETICIO (V_CODI VARCHAR2, V_DESCRIPCIO VARCHAR2, V_ZONA VARCHAR2) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        INSERT INTO COMPETICIONS
        VALUES (V_CODI, V_DESCRIPCIO, V_ZONA);
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'INSERT', 'COMPETICIO ' || V_CODI, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'INSERT', 'COMPETICIO ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END ALTA_COMPETICIO;
          
  FUNCTION BAIXA_COMPETICIO (V_CODI VARCHAR2) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        DELETE FROM COMPETICIONS C
        WHERE C.CODI = V_CODI;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'DELETE', 'COMPETICIO ' || V_CODI, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'DELETE', 'COMPETICIO ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END BAIXA_COMPETICIO;
  
  FUNCTION MODIFICA_COMPETICIO (V_CODI VARCHAR2, V_DESCRIPCIO VARCHAR2, V_ZONA VARCHAR2) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        UPDATE COMPETICIONS C 
        SET C.DESCRIPCIO = V_DESCRIPCIO,
            C.ZONA = V_ZONA
        WHERE C.CODI = V_CODI;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'UPDATE', 'COMPETICIO ' || V_CODI, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'UPDATE', 'COMPETICIO ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END MODIFICA_COMPETICIO;
  
  FUNCTION LLISTA_COMPETICIONS RETURN SYS_REFCURSOR IS
  BEGIN
    DECLARE
      RETORN SYS_REFCURSOR;
    BEGIN
      BEGIN
        OPEN RETORN FOR
        SELECT *
        FROM COMPETICIONS;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT ALL', 'COMPETICIO ', '0');
      EXCEPTION 
        WHEN OTHERS THEN
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT ALL', 'COMPETICIO ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END LLISTA_COMPETICIONS;

  FUNCTION COMPETICIO (V_CODI VARCHAR2) RETURN COMPETICIONS%ROWTYPE IS
  BEGIN
    DECLARE
      RETORN COMPETICIONS%ROWTYPE;
    BEGIN
      BEGIN
        SELECT *
        INTO RETORN
        FROM COMPETICIONS C
        WHERE C.CODI = V_CODI;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT', 'COMPETICIO ' || V_CODI, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT', 'COMPETICIO ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END COMPETICIO;
  


--
-- TEMPORADES
--
  FUNCTION ALTA_TEMPORADA (V_COMPETICIO VARCHAR2, V_AAAA NUMBER, V_INICI DATE, V_FINAL DATE) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        INSERT INTO TEMPORADES
        VALUES (V_COMPETICIO, V_AAAA, V_INICI, V_FINAL);
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'INSERT', 'TEMPORADA ' || V_COMPETICIO || ',' || V_AAAA, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'INSERT', 'TEMPORADA ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END ALTA_TEMPORADA;
          
  FUNCTION BAIXA_TEMPORADA (V_COMPETICIO VARCHAR2, V_AAAA NUMBER) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        DELETE FROM TEMPORADES T
        WHERE T.COMPETICIO = V_COMPETICIO
          AND T.AAAA = V_AAAA;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'DELETE', 'TEMPORADA ' || V_COMPETICIO || ',' || V_AAAA, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'DELETE', 'TEMPORADA ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END BAIXA_TEMPORADA;
  
  FUNCTION MODIFICA_TEMPORADA (V_COMPETICIO VARCHAR2, V_AAAA NUMBER, V_INICI DATE, V_FINAL DATE) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        UPDATE TEMPORADES T 
        SET T.INICI = V_INICI,
            T.FINAL = V_FINAL
        WHERE T.COMPETICIO = V_COMPETICIO
          AND T.AAAA = V_AAAA;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'UPDATE', 'TEMPORADA ' || V_COMPETICIO || ',' || V_AAAA, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'UPDATE', 'TEMPORADA ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END MODIFICA_TEMPORADA;
  
  FUNCTION LLISTA_TEMPORADES RETURN SYS_REFCURSOR IS
  BEGIN
    DECLARE
      RETORN SYS_REFCURSOR;
    BEGIN
      BEGIN
        OPEN RETORN FOR
        SELECT *
        FROM TEMPORADES;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT', 'TEMPORADA ', '0');
      EXCEPTION 
        WHEN OTHERS THEN
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT', 'TEMPORADA ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END LLISTA_TEMPORADES;

  FUNCTION TEMPORADA (V_COMPETICIO VARCHAR2, V_AAAA NUMBER) RETURN TEMPORADES%ROWTYPE IS
  BEGIN
    DECLARE
      RETORN TEMPORADES%ROWTYPE;
    BEGIN
      BEGIN
        SELECT *
        INTO RETORN
        FROM TEMPORADES T
        WHERE T.COMPETICIO = V_COMPETICIO
          AND T.AAAA = V_AAAA;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT', 'TEMPORADA ' || V_COMPETICIO || ',' || V_AAAA, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT', 'TEMPORADA ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END TEMPORADA;
  


--
-- EQUIPS
--
  FUNCTION ALTA_EQUIP (V_CODI VARCHAR2, V_NOM VARCHAR2, V_FUNDACIO DATE, V_PAIS VARCHAR2) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        INSERT INTO EQUIPS
        VALUES (V_CODI, V_NOM, V_FUNDACIO, V_PAIS);
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'INSERT', 'EQUIP ' || V_CODI, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'INSERT', 'EQUIP ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END ALTA_EQUIP;
          
  FUNCTION BAIXA_EQUIP (V_CODI VARCHAR2) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        DELETE FROM EQUIPS E
        WHERE E.CODI = V_CODI;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'DELETE', 'EQUIP ' || V_CODI, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'DELETE', 'EQUIP ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END BAIXA_EQUIP;
  
  FUNCTION MODIFICA_EQUIP (V_CODI VARCHAR2, V_NOM VARCHAR2, V_FUNDACIO DATE, V_PAIS VARCHAR2) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        UPDATE EQUIPS E 
        SET E.NOM = V_NOM,
            E.FUNDACIO = V_FUNDACIO,
            E.PAIS = V_PAIS
        WHERE E.CODI = V_CODI;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'UPDATE', 'EQUIP ' || V_CODI, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'UPDATE', 'EQUIP ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END MODIFICA_EQUIP;
  
  FUNCTION LLISTA_EQUIPS RETURN SYS_REFCURSOR IS
  BEGIN
    DECLARE
      RETORN SYS_REFCURSOR;
    BEGIN
      BEGIN
        OPEN RETORN FOR
        SELECT *
        FROM EQUIPS;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT ALL', 'EQUIP ', '0');
      EXCEPTION 
        WHEN OTHERS THEN
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT ALL', 'EQUIP ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END LLISTA_EQUIPS;

  FUNCTION EQUIP (V_CODI VARCHAR2) RETURN EQUIPS%ROWTYPE IS
  BEGIN
    DECLARE
      RETORN EQUIPS%ROWTYPE;
    BEGIN
      BEGIN
        SELECT *
        INTO RETORN
        FROM EQUIPS E
        WHERE E.CODI = V_CODI;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT', 'EQUIP ' || V_CODI, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT', 'EQUIP ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END EQUIP;
  


--
-- JUGADORS
--
  FUNCTION ALTA_JUGADOR (V_NOM VARCHAR2, V_COGNOM1 VARCHAR2, V_COGNOM2 VARCHAR2, V_NAIXEMENT DATE, V_NACIONALITAT VARCHAR2) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
      V_ID NUMBER;
    BEGIN
      BEGIN
        RETORN := ALTA_JUGADOR (V_NOM, V_COGNOM1, V_COGNOM2, V_NAIXEMENT, V_NACIONALITAT, V_ID);
      END;
      RETURN RETORN;
    END;
  END ALTA_JUGADOR;
  
  FUNCTION ALTA_JUGADOR (V_NOM VARCHAR2, V_COGNOM1 VARCHAR2, V_COGNOM2 VARCHAR2, V_NAIXEMENT DATE, V_NACIONALITAT VARCHAR2, V_ID IN OUT NUMBER) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        INSERT INTO JUGADORS
        VALUES (0, V_NOM, V_COGNOM1, V_COGNOM2, V_NAIXEMENT, V_NACIONALITAT)
        RETURNING ID INTO V_ID;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'INSERT', 'JUGADOR ' || V_ID, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'INSERT', 'JUGADOR ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END ALTA_JUGADOR;
          
  FUNCTION BAIXA_JUGADOR (V_ID NUMBER) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        DELETE FROM JUGADORS J
        WHERE J.ID = V_ID;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'DELETE', 'JUGADOR ' || V_ID, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'DELETE', 'JUGADOR ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END BAIXA_JUGADOR;
  
  FUNCTION MODIFICA_JUGADOR (V_ID NUMBER, V_NOM VARCHAR2, V_COGNOM1 VARCHAR2, V_COGNOM2 VARCHAR2, V_NAIXEMENT DATE, V_NACIONALITAT VARCHAR2) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        UPDATE JUGADORS J 
        SET J.NOM = V_NOM,
            J.COGNOM1 = V_COGNOM1,
            J.COGNOM2 = V_COGNOM2,
            J.NAIXEMENT = V_NAIXEMENT,
            J.NACIONALITAT = V_NACIONALITAT
        WHERE J.ID = V_ID;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'UPDATE', 'JUGADOR ' || V_ID, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'UPDATE', 'JUGADOR ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END MODIFICA_JUGADOR;
  
  FUNCTION LLISTA_JUGADORS RETURN SYS_REFCURSOR IS
  BEGIN
    DECLARE
      RETORN SYS_REFCURSOR;
    BEGIN
      BEGIN
        OPEN RETORN FOR
        SELECT *
        FROM JUGADORS;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT ALL', 'JUGADOR ', '0');
      EXCEPTION 
        WHEN OTHERS THEN
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT ALL', 'JUGADOR ' || SQLERRM, SQLCODE);
      END;

      RETURN RETORN;
    END;
  END LLISTA_JUGADORS;

  FUNCTION JUGADOR (V_ID NUMBER) RETURN JUGADORS%ROWTYPE IS
  BEGIN
    DECLARE
      RETORN JUGADORS%ROWTYPE;
    BEGIN
      BEGIN
        SELECT *
        INTO RETORN
        FROM JUGADORS J
        WHERE J.ID = V_ID;
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT', 'JUGADOR ' || V_ID, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'SELECT', 'JUGADOR ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END JUGADOR;

  FUNCTION CERCA_JUGADOR (V_NOM VARCHAR2, V_COGNOM1 VARCHAR2, V_COGNOM2 VARCHAR2) RETURN NUMBER IS
  BEGIN
    DECLARE
      RETORN NUMBER;
    BEGIN
      RETORN := 0;
      BEGIN
        SELECT MIN(J.ID)
        INTO RETORN
        FROM JUGADORS J 
        WHERE J.NOM = V_NOM
          AND J.COGNOM1 = V_COGNOM1
          AND (J.COGNOM2 = V_COGNOM2 OR J.COGNOM2 IS NULL);
        PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'CERCA', 'JUGADOR ' || RETORN || V_NOM || V_COGNOM1 || V_COGNOM2, '0');
      EXCEPTION 
        WHEN OTHERS THEN
          RETORN := SQLCODE;
          PKG_UTIL.AFEGIR_LOG (PKG_USUARIS.NOM_USUARI, 'CERCA', 'JUGADOR ' || SQLERRM, SQLCODE);
      END;
      RETURN RETORN;
    END;
  END CERCA_JUGADOR;
  
END PKG_COMPETICIONS;
/
