--
-- D_ZONES
--

CREATE TABLE D_ZONES
(
  ID NUMBER CONSTRAINT D_ZONES_ID_NN NOT NULL 
, CODI VARCHAR2(3)
, NOM VARCHAR2(50)
, CONSTRAINT D_ZONES_PK PRIMARY KEY(ID)
);

--
-- D_COMPETICIONS
--

CREATE TABLE D_COMPETICIONS
(
  ID NUMBER CONSTRAINT D_COMPETICIONS_ID_NN NOT NULL 
, CODI VARCHAR2(20)
, DESCRIPCIO VARCHAR2(50)
, CONSTRAINT D_COMPETICIONS_PK PRIMARY KEY(ID)
);

--
-- D_TEMPORADES
--

CREATE TABLE D_TEMPORADES
(
  ID NUMBER CONSTRAINT D_TEMPORADES_ID_NN NOT NULL 
, AAAA NUMBER
, CONSTRAINT D_TEMPORADES_PK PRIMARY KEY(ID)
);

--
-- D_DATES
-- 

CREATE TABLE D_DATES
(
  ID NUMBER CONSTRAINT D_DATES_ID_NN NOT NULL 
, AAAA NUMBER
, SETMANA NUMBER
, MES NUMBER 
, MES_DESC VARCHAR2(10)
, DIA NUMBER
, HORA NUMBER
, MINUT NUMBER
, SEGON NUMBER
, DIA_SETMANA VARCHAR2(10)
, CONSTRAINT D_DATES_PK PRIMARY KEY(ID)
);

--
-- D_SEXES	
--

CREATE TABLE D_SEXES
(
  ID NUMBER CONSTRAINT D_SEXES_ID_NN NOT NULL 
, SEXE VARCHAR2(1)
, CONSTRAINT D_SEXES_PK PRIMARY KEY(ID)
);

--
-- D_EDATS
--

CREATE TABLE D_EDATS
(
  ID NUMBER CONSTRAINT D_EDATS_ID_NN NOT NULL 
, EDAT NUMBER
, CONSTRAINT D_EDATS_PK PRIMARY KEY(ID)
);

--
-- D_EQUIPS
--

CREATE TABLE D_EQUIPS
(
  ID NUMBER CONSTRAINT D_EQUIPS_ID_NN NOT NULL 
, CODI VARCHAR2(3)
, NOM VARCHAR(50)
, CONSTRAINT D_EQUIPS_PK PRIMARY KEY(ID)
);

--
-- D_USUARIS
--

CREATE TABLE D_USUARIS
(
  ID NUMBER CONSTRAINT D_USUARIS_ID_NN NOT NULL 
, NOM_USUARI VARCHAR2(50)
, CONSTRAINT D_USUARIS_PK PRIMARY KEY(ID)
);

--
-- D_MODALITATS
-- 

CREATE TABLE D_MODALITATS
(
  ID NUMBER CONSTRAINT D_MODALITATS_ID_NN NOT NULL 
, DESCRIPCIO VARCHAR2(100)
, CONSTRAINT D_MODALITATS_PK PRIMARY KEY(ID)
);

--
-- F_APOSTES
--

CREATE TABLE F_APOSTES
(
  ID NUMBER CONSTRAINT F_APOSTES_ID_NN NOT NULL 
, ID_USUARI NUMBER CONSTRAINT F_APOSTES_USUARI_NN NOT NULL 
, ID_DATA NUMBER CONSTRAINT F_APOSTES_DATA_NN NOT NULL 
, ID_COMPETICIO NUMBER CONSTRAINT F_APOSTESS_COMPETICIO_NN NOT NULL 
, ID_TEMPORADA NUMBER CONSTRAINT F_APOSTES_TEMPORADA_NN NOT NULL 
, ID_MODALITAT NUMBER CONSTRAINT F_APOSTES_MODALITAT_NN NOT NULL 
, ID_EQUIP1 NUMBER CONSTRAINT F_APOSTES_EQUIP1_NN NOT NULL 
, ID_EQUIP2 NUMBER CONSTRAINT F_APOSTES_EQUIP2_NN NOT NULL 
, ID_EDAT NUMBER CONSTRAINT F_APOSTES_EDAT_NN NOT NULL 
, ID_SEXE NUMBER CONSTRAINT F_APOSTES_SEXE_NN NOT NULL 

, ID_ZONA NUMBER CONSTRAINT F_APOSTES_ZONA_NN NOT NULL 
, ID_PAIS_U NUMBER CONSTRAINT F_APOSTES_PAIS_U_NN NOT NULL 
, ID_PAIS_E1 NUMBER CONSTRAINT F_APOSTES_PAIS_E1_NN NOT NULL 
, ID_PAIS_E2 NUMBER CONSTRAINT F_APOSTES_PAIS_E2_NN NOT NULL 

, APOSTA FLOAT DEFAULT 0.00 CONSTRAINT F_APOSTES_APOSTA_NN NOT NULL 
, GUANYADORA VARCHAR(1) DEFAULT '0' CONSTRAINT F_APOSTES_GUANYADORA_NN NOT NULL 
, PAGAT FLOAT DEFAULT 0.00 CONSTRAINT F_APOSTES_PAGAT_NN NOT NULL 
, CONSTRAINT F_APOSTES_PK PRIMARY KEY(ID)

);

ALTER TABLE F_APOSTES
ADD CONSTRAINT F_APOSTES_USUARI_FK 
FOREIGN KEY(ID_USUARI) 
REFERENCES D_USUARIS(ID);

ALTER TABLE F_APOSTES
ADD CONSTRAINT F_APOSTES_DATA_FK 
FOREIGN KEY(ID_DATA) 
REFERENCES D_DATES(ID);

ALTER TABLE F_APOSTES
ADD CONSTRAINT F_APOSTES_COMPETICIO_FK 
FOREIGN KEY(ID_COMPETICIO) 
REFERENCES D_COMPETICIONS(ID);

ALTER TABLE F_APOSTES
ADD CONSTRAINT F_APOSTES_TEMPORADA_FK 
FOREIGN KEY(ID_TEMPORADA) 
REFERENCES D_TEMPORADES(ID);

ALTER TABLE F_APOSTES
ADD CONSTRAINT F_APOSTES_MODALITAT_FK 
FOREIGN KEY(ID_MODALITAT) 
REFERENCES D_MODALITATS(ID);

ALTER TABLE F_APOSTES
ADD CONSTRAINT F_APOSTES_EQUIP1_FK 
FOREIGN KEY(ID_EQUIP1) 
REFERENCES D_EQUIPS(ID);

ALTER TABLE F_APOSTES
ADD CONSTRAINT F_APOSTES_EQUIP2_FK 
FOREIGN KEY(ID_EQUIP2) 
REFERENCES D_EQUIPS(ID);

ALTER TABLE F_APOSTES
ADD CONSTRAINT F_APOSTES_EDAT_FK 
FOREIGN KEY(ID_EDAT) 
REFERENCES D_EDATS(ID);

ALTER TABLE F_APOSTES
ADD CONSTRAINT F_APOSTES_SEXE_FK 
FOREIGN KEY(ID_SEXE) 
REFERENCES D_SEXES(ID);

ALTER TABLE F_APOSTES
ADD CONSTRAINT F_APOSTES_ZONA_FK 
FOREIGN KEY(ID_ZONA) 
REFERENCES D_ZONES(ID);

ALTER TABLE F_APOSTES
ADD CONSTRAINT F_APOSTES_PAIS_U_FK 
FOREIGN KEY(ID_PAIS_U) 
REFERENCES D_ZONES(ID);

ALTER TABLE F_APOSTES
ADD CONSTRAINT F_APOSTES_PAIS_E1_FK 
FOREIGN KEY(ID_PAIS_E1) 
REFERENCES D_ZONES(ID);

ALTER TABLE F_APOSTES
ADD CONSTRAINT F_APOSTES_PAIS_E2_FK 
FOREIGN KEY(ID_PAIS_E2) 
REFERENCES D_ZONES(ID);

